 /*
    * Copyright (c) 2012, H. J. Ohlbach. All rights reserved.
    * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
    *
    * This code is free software; you can redistribute it and/or modify it
    * under the terms of the GNU General Public License version 2 only, as
    * published by the Free Software Foundation. 
    *
    * This code is distributed in the hope that it will be useful, but WITHOUT
    * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
    * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
    * version 2 for more details.
    */

package Java2OWL;
import java.lang.instrument.Instrumentation;
import org.apache.bcel.classfile.Attribute;

/** This program installs the synchroniser which transforms OWL-annotated compiled Java-classes
 * to add the synchroniser code.
 * <p> Call it with <br/>
 * java -javaagent:J2OSynchroniserAgent.jar 
 * 
 * <p> Create the jar file with <br/>
 * jar cmf Manifest.mf J2OSynchronizerAgent.jar Java2OWL/J2OSynchroniserAgent.class
 * 
 * <p>The Manifest.mf file must be
 * <pre>
   Manifest-Version: 1.0
   Premain-Class: Java2OWL.J2OSynchronizerAgent
   </pre>
 * @author ohlbach
 */
public class J2OSynchroniserAgent {
 
        public static void premain(String agentArguments, Instrumentation instrumentation) {	
            instrumentation.addTransformer(new J2OSynchroniser());
            Attribute.addAttributeReader("RuntimeVisibleAnnotations",new AnnotationReader());
            System.out.println("J2OSynchroniserAgent installed.");
	}	
}

