/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package TestPackage;

import Java2OWL.*;
import java.util.ArrayList;
import java.util.Arrays;
 

/** Multi-inheritance test. 
 *
 * @author ohlbach 
 */
@J2OWLClass(name = "Vehicle")
public class TestVehicle {
    
    public TestVehicle(){}
    public TestVehicle(String name) {this.name = name;}
    
    private String name;
    
    @J2OWLProperty(name = "hasName", setter="setName", total=true)
    public String getName() {return name;}
    
    public void setName(String name) {this.name = name;} 
    
    private ArrayList<String> owners = new ArrayList<String>();
    
    @J2OWLProperty(name = "hasOwner", adder="addOwner", remover = "removeOwner")
    public ArrayList<String> getOwners() {return owners;}
    
    public void addOwner(String owner) {owners.add(owner);}
    public void removeOwner(String owner) {owners.remove(owner);}
    
    private TestVehicle[] predecessors;
    
    @J2OWLProperty(name = "hasPredecessor", adder="addPredecessor") 
    public TestVehicle[] getPredecessors() {return predecessors;}  
    
    public void addPredecessor(TestVehicle vehicle) {
        if(predecessors == null) predecessors = new TestVehicle[]{vehicle};
        else {
            predecessors = Arrays.copyOf(predecessors, predecessors.length+1);
            predecessors[predecessors.length-1] = vehicle;};}
    
    
    @J2OWLClass(name = "Ship")
    public static class TestShip extends TestVehicle {
        private float knots;
        
        public TestShip(){}
        public TestShip(String name) {super(name);}
        
        @J2OWLProperty(name = "speed", setter="setKnots")
        public float getKnots() {return knots;}
        
        public void setKnots(float knots) {this.knots = knots;}
    }
    
    @J2OWLClass(name = "SurfaceVehicle")
    public static class TestSurfaceVehicle extends TestVehicle {
        
        public TestSurfaceVehicle(){}
        
        private double enginePower;
        
        @J2OWLProperty(name = "enginePower", setter="setEnginePower")
        public double getEnginePower() {return enginePower;}
        
        public void setEnginePower(double enginePower) {this.enginePower = enginePower;}
    }      
    
       
    public static void main(String[] args) {
        args = new String[]{"build/test/classes/TestPackage/TestVehicle.class", 
                        "exoi", "http://www.lmu.de/Vehicle.owl",
                        "exof", "test/TestPackage/Vehicle.owl",
                        "sync","true","debug","true"};
        J2OCompiler.main(args);  
       
        
    }
    
}
